/* Copyright (c) 2018 ZAO "MCST". All rights reserved. */

#ifndef _MM3DNOW_H_INCLUDED
#define _MM3DNOW_H_INCLUDED

#ifdef __3dNOW__

#include <mmintrin.h>
#include <prfchwintrin.h>

/* Define the default attributes for the functions in this file */
#define __DEFAULT_FUNCS_ATTRS __attribute__((/*__gnu_inline__,*/ __always_inline__, __artificial__))

__E2K_INLINE void __DEFAULT_FUNCS_ATTRS
_m_femms (void)
{
  __builtin_ia32_femms();
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pavgusb (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pavgusb ((__v8qi)__A, (__v8qi)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pf2id (__m64 __A)
{
  return (__m64)__builtin_ia32_pf2id ((__v2sf)__A);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfacc (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pfacc ((__v2sf)__A, (__v2sf)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfadd (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pfadd ((__v2sf)__A, (__v2sf)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfcmpeq (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pfcmpeq ((__v2sf)__A, (__v2sf)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfcmpge (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pfcmpge ((__v2sf)__A, (__v2sf)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfcmpgt (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pfcmpgt ((__v2sf)__A, (__v2sf)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfmax (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pfmax ((__v2sf)__A, (__v2sf)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfmin (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pfmin ((__v2sf)__A, (__v2sf)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfmul (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pfmul ((__v2sf)__A, (__v2sf)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfrcp (__m64 __A)
{
  return (__m64)__builtin_ia32_pfrcp ((__v2sf)__A);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfrcpit1 (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pfrcpit1 ((__v2sf)__A, (__v2sf)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfrcpit2 (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pfrcpit2 ((__v2sf)__A, (__v2sf)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfrsqrt (__m64 __A)
{
  return (__m64)__builtin_ia32_pfrsqrt ((__v2sf)__A);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfrsqit1 (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pfrsqit1 ((__v2sf)__A, (__v2sf)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfsub (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pfsub ((__v2sf)__A, (__v2sf)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfsubr (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pfsubr ((__v2sf)__A, (__v2sf)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pi2fd (__m64 __A)
{
  return (__m64)__builtin_ia32_pi2fd ((__v2si)__A);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pmulhrw (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pmulhrw ((__v4hi)__A, (__v4hi)__B);
}

__E2K_INLINE void __DEFAULT_FUNCS_ATTRS
_m_prefetch (void *__P)
{
  __builtin_prefetch (__P, 0, 3 /* _MM_HINT_T0 */);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_from_float (float __A)
{
  return __extension__ (__m64)(((union { __v2sf __f2; float f[2]; })
    {f: {__A, 0.0f}}).__f2);
}

__E2K_INLINE float __DEFAULT_FUNCS_ATTRS
_m_to_float (__m64 __A)
{
  union { __v2sf v; float a[2]; } __tmp;
  __tmp.v = (__v2sf)__A;
  return __tmp.a[0];
}

#ifdef __3dNOW_A__

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pf2iw (__m64 __A)
{
  return (__m64)__builtin_ia32_pf2iw ((__v2sf)__A);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfnacc (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pfnacc ((__v2sf)__A, (__v2sf)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pfpnacc (__m64 __A, __m64 __B)
{
  return (__m64)__builtin_ia32_pfpnacc ((__v2sf)__A, (__v2sf)__B);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pi2fw (__m64 __A)
{
  return (__m64)__builtin_ia32_pi2fw ((__v2si)__A);
}

__E2K_INLINE __m64 __DEFAULT_FUNCS_ATTRS
_m_pswapd (__m64 __A)
{
  return (__m64)__builtin_ia32_pswapdsf ((__v2sf)__A);
}

#endif /* __3dNOW_A__ */

#undef __DEFAULT_FUNCS_ATTRS

#endif /* __3dNOW__ */

#endif /* _MM3DNOW_H_INCLUDED */
